class GaussJordan {
  //takes in matrix and returns it in rref form
  static List<List<double>> solve(List<List<double>> matrix) {
    int lead = 0, rowCount = matrix.length, columnCount = matrix[1].length;
    for (int r = 0; r < rowCount; r++) {
      if (columnCount <= lead) break;
      int i = r;
      while (matrix[i][lead] == 0) {
        i++;
        if (i == rowCount) {
          i = r;
          lead++;
          if (columnCount == lead) {
            lead--;
            break;
          }
        }
      }
      for (int j = 0; j < columnCount; j++) {
        double temp = matrix[r][j];
        matrix[r][j] = matrix[i][j];
        matrix[i][j] = temp;
      }
      double div = matrix[r][lead];
      if (div != 0)
        // ignore: curly_braces_in_flow_control_structures
        for (int j = 0; j < columnCount; j++) {
          matrix[r][j] /= div;
        }
      for (int j = 0; j < rowCount; j++) {
        if (j != r) {
          double sub = matrix[j][lead];
          for (int k = 0; k < columnCount; k++) {
            matrix[j][k] -= (sub * matrix[r][k]);
          }
        }
      }
      lead++;
    }
    return matrix;
  }
}
